<?php
/*
Plugin Name: Replace Anchor Target
Plugin URI: http://www.chriswiegman.com/projects/replace-anchor-target/
Description: Replaces the <em>target="_blank"</em> attribute applied by the built-in Tinymce editor with <em>class="target_blank"</em>. This allows for easier XHTML strict compliance.
Version: 1.5
Author: ChrisWiegman
Author URI: http://www.chriswiegman.com
Disclaimer: Use at your own risk. No warranty expressed or implied is provided.
*/

/*	Copyright 2011  ChrisWiegman  (email : chris@chriswiegman.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

wp_enqueue_script('replace_anchor_target', '/wp-content/plugins/replace-target/target.js', array('jquery'));

add_filter('the_content','filter_replace_anchor_target');

function filter_replace_anchor_target($content) {

	$offSet = 0;
	
	while ($startLink = stripos(substr($content,$offSet,strlen($content)),'<a')) {

		$linkStart = $startLink + $offSet; 
		
		$endLink = stripos(substr($content,$linkStart,strlen($content)),'>');
			
		$link = substr($content,$linkStart,$endLink); 
		
		if (strstr($link,'target="_blank"')) {
			if (strstr($link,'class="')) {
				$link = str_ireplace(' target="_blank"','',$link);
				$link = str_ireplace('class="','class="target_blank ',$link);
			} else {
				$link = str_ireplace('target="_blank"','class="target_blank"',$link);
			}
			$newLinkSize = strlen($link);
			$content = substr_replace($content,$link,$linkStart,$endLink);
		}
		$offSet = $linkStart + $newLinkSize;
	}
	
	return $content;

}

add_action('admin_menu', 'replace_anchor_target_menu');

function replace_anchor_target_menu() {

	add_options_page('Replace Anchor Target', 'Replace Anchor Target', 'manage_options', 'replace-anchor-target/Options.php');

}
